using System.Collections.Generic;
using System.Collections;
using System;
using System.Linq;
using Aurora.Utils;

#nullable enable
namespace Aurora.Cursor
{

    public class CursorList<T> : SortedList<string, T> where T : ICursorObject
    {

        public CursorList()
        {
        }

        public CursorList<T> Add(T item)
        {
            string id = item.Id;
            if (item.Id == null)
            {
                id = HashUtil.GetHash(new string[] { item.GetHashCode().ToString() }).ToString();
                item.Id = id;
            }
            bool res = this.TryAdd(id, item);

            if (res == false)
            {
                throw new System.Exception("Failed to add item to cursor list");
            }
            return this;
        }


    }
}